Browse Source

Initial release

This commit contains the scripts to download from source QEMU
and libvirt, specify a specific commit ID and apply on top
of it a list of patches.

Change-Id: Id52690f4f175c990f0b481c900a30087c07c0c31
Rodolfo Alonso Hernandez 1 year ago
parent
commit
fa342a7900

+ 58
- 0
.gitignore View File

@@ -0,0 +1,58 @@
1
+*.py[cod]
2
+
3
+# C extensions
4
+*.so
5
+
6
+# Packages
7
+*.egg*
8
+*.egg-info
9
+dist
10
+build
11
+eggs
12
+parts
13
+bin
14
+var
15
+sdist
16
+develop-eggs
17
+.installed.cfg
18
+lib
19
+lib64
20
+
21
+# Installer logs
22
+pip-log.txt
23
+
24
+# Unit test / coverage reports
25
+cover/
26
+.coverage*
27
+!.coveragerc
28
+.tox
29
+nosetests.xml
30
+.testrepository
31
+.venv
32
+
33
+# Translations
34
+*.mo
35
+
36
+# Mr Developer
37
+.mr.developer.cfg
38
+.project
39
+.pydevproject
40
+
41
+# Complexity
42
+output/*.html
43
+output/*/index.html
44
+
45
+# Sphinx
46
+doc/build
47
+
48
+# pbr generates these
49
+AUTHORS
50
+ChangeLog
51
+
52
+# Editors
53
+*~
54
+.*.swp
55
+.*sw?
56
+
57
+# Files created by releasenotes build
58
+releasenotes/build

+ 3
- 0
.mailmap View File

@@ -0,0 +1,3 @@
1
+# Format is:
2
+# <preferred e-mail> <other e-mail 1>
3
+# <preferred e-mail> <other e-mail 2>

+ 7
- 0
.testr.conf View File

@@ -0,0 +1,7 @@
1
+[DEFAULT]
2
+test_command=OS_STDOUT_CAPTURE=${OS_STDOUT_CAPTURE:-1} \
3
+             OS_STDERR_CAPTURE=${OS_STDERR_CAPTURE:-1} \
4
+             OS_TEST_TIMEOUT=${OS_TEST_TIMEOUT:-60} \
5
+             ${PYTHON:-python} -m subunit.run discover -t ./ . $LISTOPT $IDOPTION
6
+test_id_option=--load-list $IDFILE
7
+test_list_option=--list

+ 17
- 0
CONTRIBUTING.rst View File

@@ -0,0 +1,17 @@
1
+If you would like to contribute to the development of OpenStack, you must
2
+follow the steps in this page:
3
+
4
+   http://docs.openstack.org/infra/manual/developers.html
5
+
6
+If you already have a good understanding of how the system works and your
7
+OpenStack accounts are set up, you can skip to the development workflow
8
+section of this documentation to learn how changes to OpenStack should be
9
+submitted for review via the Gerrit tool:
10
+
11
+   http://docs.openstack.org/infra/manual/developers.html#development-workflow
12
+
13
+Pull requests submitted through GitHub will be ignored.
14
+
15
+Bugs should be filed on Launchpad, not GitHub:
16
+
17
+   https://bugs.launchpad.net/devstack-plugin-libvirt-qemu

+ 4
- 0
HACKING.rst View File

@@ -0,0 +1,4 @@
1
+devstack-plugin-libvirt-qemu Style Commandments
2
+===============================================
3
+
4
+Read the OpenStack Style Commandments http://docs.openstack.org/developer/hacking/

+ 176
- 0
LICENSE View File

@@ -0,0 +1,176 @@
1
+
2
+                                 Apache License
3
+                           Version 2.0, January 2004
4
+                        http://www.apache.org/licenses/
5
+
6
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
7
+
8
+   1. Definitions.
9
+
10
+      "License" shall mean the terms and conditions for use, reproduction,
11
+      and distribution as defined by Sections 1 through 9 of this document.
12
+
13
+      "Licensor" shall mean the copyright owner or entity authorized by
14
+      the copyright owner that is granting the License.
15
+
16
+      "Legal Entity" shall mean the union of the acting entity and all
17
+      other entities that control, are controlled by, or are under common
18
+      control with that entity. For the purposes of this definition,
19
+      "control" means (i) the power, direct or indirect, to cause the
20
+      direction or management of such entity, whether by contract or
21
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
22
+      outstanding shares, or (iii) beneficial ownership of such entity.
23
+
24
+      "You" (or "Your") shall mean an individual or Legal Entity
25
+      exercising permissions granted by this License.
26
+
27
+      "Source" form shall mean the preferred form for making modifications,
28
+      including but not limited to software source code, documentation
29
+      source, and configuration files.
30
+
31
+      "Object" form shall mean any form resulting from mechanical
32
+      transformation or translation of a Source form, including but
33
+      not limited to compiled object code, generated documentation,
34
+      and conversions to other media types.
35
+
36
+      "Work" shall mean the work of authorship, whether in Source or
37
+      Object form, made available under the License, as indicated by a
38
+      copyright notice that is included in or attached to the work
39
+      (an example is provided in the Appendix below).
40
+
41
+      "Derivative Works" shall mean any work, whether in Source or Object
42
+      form, that is based on (or derived from) the Work and for which the
43
+      editorial revisions, annotations, elaborations, or other modifications
44
+      represent, as a whole, an original work of authorship. For the purposes
45
+      of this License, Derivative Works shall not include works that remain
46
+      separable from, or merely link (or bind by name) to the interfaces of,
47
+      the Work and Derivative Works thereof.
48
+
49
+      "Contribution" shall mean any work of authorship, including
50
+      the original version of the Work and any modifications or additions
51
+      to that Work or Derivative Works thereof, that is intentionally
52
+      submitted to Licensor for inclusion in the Work by the copyright owner
53
+      or by an individual or Legal Entity authorized to submit on behalf of
54
+      the copyright owner. For the purposes of this definition, "submitted"
55
+      means any form of electronic, verbal, or written communication sent
56
+      to the Licensor or its representatives, including but not limited to
57
+      communication on electronic mailing lists, source code control systems,
58
+      and issue tracking systems that are managed by, or on behalf of, the
59
+      Licensor for the purpose of discussing and improving the Work, but
60
+      excluding communication that is conspicuously marked or otherwise
61
+      designated in writing by the copyright owner as "Not a Contribution."
62
+
63
+      "Contributor" shall mean Licensor and any individual or Legal Entity
64
+      on behalf of whom a Contribution has been received by Licensor and
65
+      subsequently incorporated within the Work.
66
+
67
+   2. Grant of Copyright License. Subject to the terms and conditions of
68
+      this License, each Contributor hereby grants to You a perpetual,
69
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
70
+      copyright license to reproduce, prepare Derivative Works of,
71
+      publicly display, publicly perform, sublicense, and distribute the
72
+      Work and such Derivative Works in Source or Object form.
73
+
74
+   3. Grant of Patent License. Subject to the terms and conditions of
75
+      this License, each Contributor hereby grants to You a perpetual,
76
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
77
+      (except as stated in this section) patent license to make, have made,
78
+      use, offer to sell, sell, import, and otherwise transfer the Work,
79
+      where such license applies only to those patent claims licensable
80
+      by such Contributor that are necessarily infringed by their
81
+      Contribution(s) alone or by combination of their Contribution(s)
82
+      with the Work to which such Contribution(s) was submitted. If You
83
+      institute patent litigation against any entity (including a
84
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
85
+      or a Contribution incorporated within the Work constitutes direct
86
+      or contributory patent infringement, then any patent licenses
87
+      granted to You under this License for that Work shall terminate
88
+      as of the date such litigation is filed.
89
+
90
+   4. Redistribution. You may reproduce and distribute copies of the
91
+      Work or Derivative Works thereof in any medium, with or without
92
+      modifications, and in Source or Object form, provided that You
93
+      meet the following conditions:
94
+
95
+      (a) You must give any other recipients of the Work or
96
+          Derivative Works a copy of this License; and
97
+
98
+      (b) You must cause any modified files to carry prominent notices
99
+          stating that You changed the files; and
100
+
101
+      (c) You must retain, in the Source form of any Derivative Works
102
+          that You distribute, all copyright, patent, trademark, and
103
+          attribution notices from the Source form of the Work,
104
+          excluding those notices that do not pertain to any part of
105
+          the Derivative Works; and
106
+
107
+      (d) If the Work includes a "NOTICE" text file as part of its
108
+          distribution, then any Derivative Works that You distribute must
109
+          include a readable copy of the attribution notices contained
110
+          within such NOTICE file, excluding those notices that do not
111
+          pertain to any part of the Derivative Works, in at least one
112
+          of the following places: within a NOTICE text file distributed
113
+          as part of the Derivative Works; within the Source form or
114
+          documentation, if provided along with the Derivative Works; or,
115
+          within a display generated by the Derivative Works, if and
116
+          wherever such third-party notices normally appear. The contents
117
+          of the NOTICE file are for informational purposes only and
118
+          do not modify the License. You may add Your own attribution
119
+          notices within Derivative Works that You distribute, alongside
120
+          or as an addendum to the NOTICE text from the Work, provided
121
+          that such additional attribution notices cannot be construed
122
+          as modifying the License.
123
+
124
+      You may add Your own copyright statement to Your modifications and
125
+      may provide additional or different license terms and conditions
126
+      for use, reproduction, or distribution of Your modifications, or
127
+      for any such Derivative Works as a whole, provided Your use,
128
+      reproduction, and distribution of the Work otherwise complies with
129
+      the conditions stated in this License.
130
+
131
+   5. Submission of Contributions. Unless You explicitly state otherwise,
132
+      any Contribution intentionally submitted for inclusion in the Work
133
+      by You to the Licensor shall be under the terms and conditions of
134
+      this License, without any additional terms or conditions.
135
+      Notwithstanding the above, nothing herein shall supersede or modify
136
+      the terms of any separate license agreement you may have executed
137
+      with Licensor regarding such Contributions.
138
+
139
+   6. Trademarks. This License does not grant permission to use the trade
140
+      names, trademarks, service marks, or product names of the Licensor,
141
+      except as required for reasonable and customary use in describing the
142
+      origin of the Work and reproducing the content of the NOTICE file.
143
+
144
+   7. Disclaimer of Warranty. Unless required by applicable law or
145
+      agreed to in writing, Licensor provides the Work (and each
146
+      Contributor provides its Contributions) on an "AS IS" BASIS,
147
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
148
+      implied, including, without limitation, any warranties or conditions
149
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
150
+      PARTICULAR PURPOSE. You are solely responsible for determining the
151
+      appropriateness of using or redistributing the Work and assume any
152
+      risks associated with Your exercise of permissions under this License.
153
+
154
+   8. Limitation of Liability. In no event and under no legal theory,
155
+      whether in tort (including negligence), contract, or otherwise,
156
+      unless required by applicable law (such as deliberate and grossly
157
+      negligent acts) or agreed to in writing, shall any Contributor be
158
+      liable to You for damages, including any direct, indirect, special,
159
+      incidental, or consequential damages of any character arising as a
160
+      result of this License or out of the use or inability to use the
161
+      Work (including but not limited to damages for loss of goodwill,
162
+      work stoppage, computer failure or malfunction, or any and all
163
+      other commercial damages or losses), even if such Contributor
164
+      has been advised of the possibility of such damages.
165
+
166
+   9. Accepting Warranty or Additional Liability. While redistributing
167
+      the Work or Derivative Works thereof, You may choose to offer,
168
+      and charge a fee for, acceptance of support, warranty, indemnity,
169
+      or other liability obligations and/or rights consistent with this
170
+      License. However, in accepting such obligations, You may act only
171
+      on Your own behalf and on Your sole responsibility, not on behalf
172
+      of any other Contributor, and only if You agree to indemnify,
173
+      defend, and hold each Contributor harmless for any liability
174
+      incurred by, or claims asserted against, such Contributor by reason
175
+      of your accepting any such warranty or additional liability.
176
+

+ 19
- 0
README.rst View File

@@ -0,0 +1,19 @@
1
+===============================
2
+devstack-plugin-libvirt-qemu
3
+===============================
4
+
5
+OpenStack Boilerplate contains all the boilerplate you need to create an OpenStack package.
6
+
7
+Please fill here a long description which must be at least 3 lines wrapped on
8
+80 cols, so that distribution package maintainers can use it in their packages.
9
+Note that this is a hard requirement.
10
+
11
+* Free software: Apache license
12
+* Documentation: http://docs.openstack.org/developer/devstack-plugin-libvirt-qemu
13
+* Source: http://git.openstack.org/cgit/devstack-plugin-libvirt-qemu/devstack-plugin-libvirt-qemu
14
+* Bugs: http://bugs.launchpad.net/devstack-plugin-libvirt-qemu
15
+
16
+Features
17
+--------
18
+
19
+* TODO

+ 2
- 0
babel.cfg View File

@@ -0,0 +1,2 @@
1
+[python: **.py]
2
+

+ 223
- 0
devstack/libs/libvirt View File

@@ -0,0 +1,223 @@
1
+#!/bin/bash
2
+#
3
+# common functions for devstack-libvirt-qemu plugin
4
+# -------------------------------------
5
+
6
+#
7
+# ovs installation
8
+#
9
+
10
+#
11
+# git_update_repo
12
+# Due to missing support in devstack, this local function can handle
13
+# updating / refreshing repos based on commit id
14
+# it's taking following arguments
15
+# $1 .. path to repo, $2 .. commit/tag for update of existing repo
16
+#
17
+function git_update_repo {
18
+    local git_dest=$1
19
+    local git_ref=$2
20
+
21
+    pushd $git_dest
22
+    git fetch
23
+    git checkout -f $git_ref # Clean modified tracked files
24
+    git clean -d -f # Clean untracked files
25
+    popd
26
+}
27
+
28
+function clone_repo {
29
+    local git_remote=$1
30
+    local git_dest=$2
31
+    local git_ref=$3
32
+
33
+    git_timed clone $git_remote $git_dest
34
+    pushd $git_dest
35
+    git checkout -f $git_ref # Clean modified tracked files
36
+    git clean -d -f # Clean untracked files
37
+    popd
38
+}
39
+
40
+function get_repo {
41
+    local git_remote=$1
42
+    local git_ref=$2
43
+    local git_dest=$3
44
+
45
+    if [ ! -d $git_dest ] || [ "$RECLONE" == True ]; then
46
+        # If directory exists and should be just refreshed
47
+        # it's not possible to use devstack git_clone with commit's id
48
+        if [ -d $git_dest} ]; then
49
+            git_update_repo $git_dest $git_ref
50
+        else
51
+            git_clone $git_remote $git_dest $git_ref
52
+        fi
53
+    fi
54
+}
55
+
56
+function patch_repo {
57
+    if [ "$LIBVIRT_PATCHES" != "" ]; then
58
+        # $1 destination, $2 commit/branch/tag, $3 patch urls (space seperated)
59
+        pushd  $1
60
+           git clean -f -x -d
61
+           git reset --hard $2
62
+           local patches=( $3 )
63
+           for url in "${patches[@]}"; do
64
+               curl $url | patch -p1
65
+           done
66
+        popd
67
+    fi
68
+
69
+}
70
+
71
+function clone_libvirt_qemu {
72
+    OFFLINE=$(trueorfalse False OFFLINE)
73
+    RECLONE=$(trueorfalse False RECLONE)
74
+    if [[ "$OFFLINE" != True && ( "$RECLONE" == True || ! -e ${LIBVIRT_DIR}/BUILD_COMPLETE ) ]]; then
75
+        get_repo $LIBVIRT_REPO $LIBVIRT_BRANCH $LIBVIRT_DIR
76
+        patch_repo $LIBVIRT_REPO $LIBVIRT_BRANCH $LIBVIRT_PATCHES
77
+        get_repo $QEMU_REPO $QEMU_BRANCH $QEMU_DIR
78
+        patch_repo $QEMU_REPO $QEMU_BRANCH $QEMU_PATCHES
79
+    fi
80
+}
81
+
82
+function install_libvirt_src {
83
+    if [ -e "${LIBVIRT_DIR}/BUILD_COMPLETE" ]; then
84
+        echo "Libvirt already built."
85
+        pushd ${LIBVIRT_DIR}
86
+            sudo make install
87
+        popd
88
+        return
89
+    fi
90
+    pushd ${LIBVIRT_DIR}
91
+        ./autogen.sh --system
92
+        make -j $(nproc) EXTRA_CFLAGS='-fPIC'
93
+        sudo make install
94
+        touch ${LIBVIRT_DIR}/BUILD_COMPLETE
95
+    popd
96
+}
97
+
98
+function install_qemu_src {
99
+    if [ -e "${QEMU_DIR}/BUILD_COMPLETE" ]; then
100
+        echo "Qemu already built."
101
+        pushd ${QEMU_DIR}
102
+            sudo make install
103
+        popd
104
+        return
105
+    fi
106
+    pushd ${QEMU_DIR}
107
+        # FIXME(ralonsoh): libfdt 1.4.2 not present in Ubuntu repositories.
108
+        git submodule update --init dtc
109
+        ./configure
110
+        make -j $(nproc) EXTRA_CFLAGS='-fPIC'
111
+        sudo make install
112
+        touch ${QEMU_DIR}/BUILD_COMPLETE
113
+    popd
114
+}
115
+
116
+function add_repositories {
117
+    if is_ubuntu; then
118
+        if ! [[ $(dpkg --get-selections | ag software-properties-common) ]]; then
119
+            sudo_with_proxies apt-get install -y software-properties-common
120
+        fi
121
+        sudo_with_proxies add-apt-repository -s 'deb http://archive.ubuntu.com/ubuntu/ xenial main'
122
+        sudo_with_proxies apt-get update
123
+    #else
124
+        #TODO(ralonsoh): add Red Hat needed repositories.
125
+    fi
126
+}
127
+
128
+function install_build_deps {
129
+    if is_ubuntu; then
130
+        sudo_with_proxies apt-get build-dep -y $1
131
+    else
132
+        [ rpm -qa | grep yum-builddep > /dev/null ] && sudo_with_proxies yum install -y yum-builddep
133
+        sudo_with_proxies yum-builddep -y $1
134
+    fi
135
+}
136
+
137
+function configure_libvirtd_src {
138
+    cat << EOF | sudo tee /etc/libvirt/libvirtd.conf
139
+unix_sock_group = "libvirt"
140
+unix_sock_ro_perms = "0660"
141
+unix_sock_rw_perms = "0660"
142
+unix_sock_admin_perms = "0660"
143
+EOF
144
+}
145
+
146
+function configure_groups_users {
147
+    getent group libvirt > /dev/null || sudo addgroup -f -r libvirt
148
+    sudo usermod -G libvirt -a root
149
+    getent group kvm > /dev/null || sudo groupadd -f -r kvm
150
+    getent group qemu > /dev/null || sudo groupadd -f -r qemu
151
+    getent passwd qemu > /dev/null || sudo useradd -r -g qemu -G kvm -d / -s /sbin/nologin -c "qemu user" qemu
152
+}
153
+
154
+function install_libvirt_qemu_src {
155
+    # Install deps
156
+    set +o errexit
157
+    if is_ubuntu; then
158
+        if [ dpkg -s libvirt-bin | grep installed > /dev/null ]; then
159
+            stop_service libvirt-bin
160
+        fi
161
+        if [ dpkg -s libvirt0 | grep installed > /dev/null ]; then
162
+            apt-get remove --purge libvirt0
163
+        fi
164
+        add_repositories
165
+        install_build_deps libvirt-bin
166
+        install_build_deps qemu-kvm
167
+		install_package libnuma-dev gcc make build-essential autopoint
168
+    else
169
+        if [ rpm -qa | grep libvirtd > /dev/null ]; then
170
+            stop_service libvirtd
171
+        fi
172
+        if [ rpm -qa | grep libvirt0 > /dev/null ]; then
173
+            yum remove libvirt0
174
+        fi
175
+        install_build_deps libvirtd
176
+        install_build_deps qemu
177
+        install_package libnuma-devel gcc make autopoint pkg-config
178
+    fi
179
+    set -o errexit
180
+
181
+    install_libvirt_src
182
+    install_qemu_src
183
+    if is_ubuntu; then
184
+        sudo ln -s -f /usr/lib/systemd/system/libvirtd.service /usr/lib/systemd/system/libvirt-bin.service
185
+    fi
186
+    type systemctl 2>&1 >/dev/null && sudo systemctl daemon-reload
187
+
188
+    configure_libvirtd_src
189
+
190
+    configure_groups_users
191
+
192
+    if is_ubuntu; then
193
+        sudo apparmor_parser -R /etc/apparmor.d/usr.sbin.libvirtd || /bin/true
194
+        start_service libvirt-bin
195
+    else
196
+        #TODO(ralonsoh): check if Red Hat needs selinux permissive mode
197
+        start_service libvirtd
198
+    fi
199
+    start_service virtlogd
200
+    sudo_with_proxies pip install -U libvirt-python
201
+}
202
+
203
+function cleanup_libvirt_qemu_source {
204
+    sudo rm -rf ${LIBVIRT_DIR}
205
+    sudo rm -rf ${QEMU_DIR}
206
+}
207
+
208
+function uninstall_libvirt_qemu {
209
+    pushd ${LIBVIRT_DIR}
210
+        sudo make uninstall
211
+    popd
212
+    pushd ${QEMU_DIR}
213
+        sudo make uninstall
214
+    popd
215
+}
216
+
217
+
218
+# if we are installing libvirt and qemu dont install distro packages.
219
+if [ $LIBVIRT_QEMU_SRC_INSTALL == 'True' ]; then
220
+function install_libvirt {
221
+    install_libvirt_qemu_src
222
+}
223
+fi

+ 56
- 0
devstack/plugin.sh View File

@@ -0,0 +1,56 @@
1
+#!/bin/bash
2
+
3
+#local xtrace=$(set +o | grep xtrace)
4
+
5
+if [ "$VERBOSE" == 'True' ]; then
6
+    # enabling verbosity on whole plugin - default behavior
7
+    set -o xtrace
8
+fi
9
+
10
+local error_on_clone=${ERROR_ON_CLONE}
11
+# disabling ERROR_NO_CLONE to allow this plugin work with devstack-gate
12
+ERROR_ON_CLONE=False
13
+
14
+    # Initial source of lib script
15
+    source $DEVSTACK_LIBVIRT_QEMU_PLUGIN_DIR/devstack/libs/libvirt
16
+
17
+    case $1 in
18
+        "stack")
19
+            case $2 in
20
+                "pre-install")
21
+                    # cloning source code
22
+                    if [ $LIBVIRT_QEMU_SRC_INSTALL == 'True' ]; then
23
+                        echo_summary "Downloading source repos for libvirt and qemu"
24
+                        clone_libvirt_qemu
25
+                    else
26
+                        echo_summary "Cloning of src files for libvirt and qemu disabled"
27
+                    fi
28
+                ;;
29
+                "install")
30
+                    # no-op
31
+                    # install called via by devstack/lib/nova
32
+                    :
33
+                ;;
34
+                "post-config")
35
+                    # no-op
36
+                    :
37
+                ;;
38
+                "extra")
39
+                    # no-op
40
+                    :
41
+                ;;
42
+            esac
43
+        ;;
44
+        "unstack")
45
+            # Shut Down OVS-DPDK
46
+            uninstall_libvirt_qemu
47
+        ;;
48
+        "clean")
49
+            # Remove state and transient data
50
+            # Remember clean.sh first calls unstack.sh
51
+            cleanup_libvirt_qemu_source
52
+        ;;
53
+    esac
54
+
55
+ERROR_ON_CLONE=$error_on_clone
56
+$xtrace

+ 25
- 0
devstack/settings View File

@@ -0,0 +1,25 @@
1
+if [ "$VERBOSE" == "False" ]; then
2
+    # allow local debugging
3
+    set -o xtrace
4
+fi
5
+
6
+DEVSTACK_LIBVIRT_QEMU_PLUGIN_DIR=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && cd .. && pwd )
7
+
8
+LIBVIRT_QEMU_SRC_INSTALL=${LIBVIRT_QEMU_SRC_INSTALL:-'True'}
9
+
10
+LIBVIRT_REPO=${LIBVIRT_REPO:-'https://github.com/libvirt/libvirt'}
11
+LIBVIRT_BRANCH=${LIBVIRT_BRANCH:-'master'}
12
+LIBVIRT_DIR=${LIBVIRT_DIR:-"${DEST}/libvirt"}
13
+
14
+QEMU_REPO=${QEMU_REPO:-'https://github.com/qemu/qemu'}
15
+QEMU_BRANCH=${QEMU_BRANCH:-'master'}
16
+QEMU_DIR=${QEMU_DIR:-"${DEST}/qemu"}
17
+
18
+# Do not apply any patches by default
19
+LIBVIRT_PATCHES=${LIBVIRT_PATCHES:-''}
20
+QEMU_PATCHES=${QEMU_PATCHES:-''}
21
+
22
+if [ "$VERBOSE" == "False" ]; then
23
+    # turn off debugging again
24
+    set +o xtrace
25
+fi

+ 75
- 0
doc/source/conf.py View File

@@ -0,0 +1,75 @@
1
+# -*- coding: utf-8 -*-
2
+# Licensed under the Apache License, Version 2.0 (the "License");
3
+# you may not use this file except in compliance with the License.
4
+# You may obtain a copy of the License at
5
+#
6
+#    http://www.apache.org/licenses/LICENSE-2.0
7
+#
8
+# Unless required by applicable law or agreed to in writing, software
9
+# distributed under the License is distributed on an "AS IS" BASIS,
10
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
11
+# implied.
12
+# See the License for the specific language governing permissions and
13
+# limitations under the License.
14
+
15
+import os
16
+import sys
17
+
18
+sys.path.insert(0, os.path.abspath('../..'))
19
+# -- General configuration ----------------------------------------------------
20
+
21
+# Add any Sphinx extension module names here, as strings. They can be
22
+# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
23
+extensions = [
24
+    'sphinx.ext.autodoc',
25
+    #'sphinx.ext.intersphinx',
26
+    'oslosphinx'
27
+]
28
+
29
+# autodoc generation is a bit aggressive and a nuisance when doing heavy
30
+# text edit cycles.
31
+# execute "export SPHINX_DEBUG=1" in your terminal to disable
32
+
33
+# The suffix of source filenames.
34
+source_suffix = '.rst'
35
+
36
+# The master toctree document.
37
+master_doc = 'index'
38
+
39
+# General information about the project.
40
+project = u'devstack-plugin-libvirt-qemu'
41
+copyright = u'2016, OpenStack Foundation'
42
+
43
+# If true, '()' will be appended to :func: etc. cross-reference text.
44
+add_function_parentheses = True
45
+
46
+# If true, the current module name will be prepended to all description
47
+# unit titles (such as .. function::).
48
+add_module_names = True
49
+
50
+# The name of the Pygments (syntax highlighting) style to use.
51
+pygments_style = 'sphinx'
52
+
53
+# -- Options for HTML output --------------------------------------------------
54
+
55
+# The theme to use for HTML and HTML Help pages.  Major themes that come with
56
+# Sphinx are currently 'default' and 'sphinxdoc'.
57
+# html_theme_path = ["."]
58
+# html_theme = '_theme'
59
+# html_static_path = ['static']
60
+
61
+# Output file base name for HTML help builder.
62
+htmlhelp_basename = '%sdoc' % project
63
+
64
+# Grouping the document tree into LaTeX files. List of tuples
65
+# (source start file, target name, title, author, documentclass
66
+# [howto/manual]).
67
+latex_documents = [
68
+    ('index',
69
+     '%s.tex' % project,
70
+     u'%s Documentation' % project,
71
+     u'OpenStack Foundation', 'manual'),
72
+]
73
+
74
+# Example configuration for intersphinx: refer to the Python standard library.
75
+#intersphinx_mapping = {'http://docs.python.org/': None}

+ 4
- 0
doc/source/contributing.rst View File

@@ -0,0 +1,4 @@
1
+============
2
+Contributing
3
+============
4
+.. include:: ../../CONTRIBUTING.rst

+ 25
- 0
doc/source/index.rst View File

@@ -0,0 +1,25 @@
1
+.. devstack-plugin-libvirt-qemu documentation master file, created by
2
+   sphinx-quickstart on Tue Jul  9 22:26:36 2013.
3
+   You can adapt this file completely to your liking, but it should at least
4
+   contain the root `toctree` directive.
5
+
6
+Welcome to devstack-plugin-libvirt-qemu's documentation!
7
+========================================================
8
+
9
+Contents:
10
+
11
+.. toctree::
12
+   :maxdepth: 2
13
+
14
+   readme
15
+   installation
16
+   usage
17
+   contributing
18
+
19
+Indices and tables
20
+==================
21
+
22
+* :ref:`genindex`
23
+* :ref:`modindex`
24
+* :ref:`search`
25
+

+ 26
- 0
doc/source/installation.rst View File

@@ -0,0 +1,26 @@
1
+============
2
+Installation
3
+============
4
+
5
+At the command line::
6
+
7
+    $ pip install devstack-plugin-libvirt-qemu
8
+
9
+Or, if you have virtualenvwrapper installed::
10
+
11
+    $ mkvirtualenv devstack-plugin-libvirt-qemu
12
+    $ pip install devstack-plugin-libvirt-qemu
13
+
14
+
15
+Notes
16
+=====
17
+
18
+``libvirt`` needs ``python-libvirt`` library to be used in OpenStack. The
19
+version downloaded and compiled must have a compatible Python API binding
20
+available to be installed. Check `The libvirt virtualization API python binding
21
+<https://pypi.python.org/pypi/libvirt-python>`_ to find the list of available
22
+versions to be installed.
23
+
24
+This plugin has been tested manually only in:
25
+
26
+* Ubuntu 16.04

+ 1
- 0
doc/source/readme.rst View File

@@ -0,0 +1 @@
1
+.. include:: ../../README.rst

+ 7
- 0
doc/source/usage.rst View File

@@ -0,0 +1,7 @@
1
+=====
2
+Usage
3
+=====
4
+
5
+To use devstack-plugin-libvirt-qemu in a project::
6
+
7
+    import devstack_plugin_libvirt_qemu

+ 25
- 0
readme.md View File

@@ -0,0 +1,25 @@
1
+============================
2
+devstack-plugin-libvirt-qemu
3
+============================
4
+
5
+This project is a set of scripts to be executed along with DevStack. DevStack
6
+is a set of scripts and utilities to quickly deploy an OpenStack cloud.
7
+
8
+This DevStack plugin provides the ability to download from the source and
9
+compile libvirt and QEMU. Also gives the ability to set an specific git commit
10
+to be used in the compilation
11
+
12
+A Collection of Agents and Drivers to support managing DPDK accelerated Open
13
+vSwitch with neutron.
14
+
15
+* Free software: Apache license
16
+* Source: https://github.com/openstack/devstack-plugin-libvirt-qemu
17
+
18
+
19
+The following are links to background information that provide additional
20
+insight into the related programs used in this project:
21
+
22
+* libvirt
23
+  - Official libvirt website: https://github.com/openstack/devstack-plugin-libvirt-qemu
24
+* Qemu:
25
+  - Official QEMU website: http://www.qemu.org/

+ 0
- 0
releasenotes/notes/.placeholder View File


+ 12
- 0
releasenotes/notes/initial_release-6ee97b0a3ef70187.yaml View File

@@ -0,0 +1,12 @@
1
+---
2
+prelude: >
3
+    This project is a plugin for DevStack. Gives the ability to download and
4
+    compile libvirt and QEMU from source.
5
+features:
6
+  - |
7
+    To compile libvirt and QEMU from source during the installation time while
8
+    executing DevStack.
9
+  - |
10
+    To set a git commmit id, tag or branch name for both projects.
11
+  - |
12
+    To list a set o patches to be applied on top of the downloaded source code.

+ 0
- 0
releasenotes/source/_static/.placeholder View File


+ 0
- 0
releasenotes/source/_templates/.placeholder View File


+ 275
- 0
releasenotes/source/conf.py View File

@@ -0,0 +1,275 @@
1
+# -*- coding: utf-8 -*-
2
+# Licensed under the Apache License, Version 2.0 (the "License");
3
+# you may not use this file except in compliance with the License.
4
+# You may obtain a copy of the License at
5
+#
6
+#    http://www.apache.org/licenses/LICENSE-2.0
7
+#
8
+# Unless required by applicable law or agreed to in writing, software
9
+# distributed under the License is distributed on an "AS IS" BASIS,
10
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
11
+# implied.
12
+# See the License for the specific language governing permissions and
13
+# limitations under the License.
14
+
15
+# Glance Release Notes documentation build configuration file, created by
16
+# sphinx-quickstart on Tue Nov  3 17:40:50 2015.
17
+#
18
+# This file is execfile()d with the current directory set to its
19
+# containing dir.
20
+#
21
+# Note that not all possible configuration values are present in this
22
+# autogenerated file.
23
+#
24
+# All configuration values have a default; values that are commented out
25
+# serve to show the default.
26
+
27
+# If extensions (or modules to document with autodoc) are in another directory,
28
+# add these directories to sys.path here. If the directory is relative to the
29
+# documentation root, use os.path.abspath to make it absolute, like shown here.
30
+# sys.path.insert(0, os.path.abspath('.'))
31
+
32
+# -- General configuration ------------------------------------------------
33
+
34
+# If your documentation needs a minimal Sphinx version, state it here.
35
+# needs_sphinx = '1.0'
36
+
37
+# Add any Sphinx extension module names here, as strings. They can be
38
+# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
39
+# ones.
40
+extensions = [
41
+    'oslosphinx',
42
+    'reno.sphinxext',
43
+]
44
+
45
+# Add any paths that contain templates here, relative to this directory.
46
+templates_path = ['_templates']
47
+
48
+# The suffix of source filenames.
49
+source_suffix = '.rst'
50
+
51
+# The encoding of source files.
52
+# source_encoding = 'utf-8-sig'
53
+
54
+# The master toctree document.
55
+master_doc = 'index'
56
+
57
+# General information about the project.
58
+project = u'devstack_plugin_libvirt_qemu Release Notes'
59
+copyright = u'2016, OpenStack Foundation'
60
+
61
+# The version info for the project you're documenting, acts as replacement for
62
+# |version| and |release|, also used in various other places throughout the
63
+# built documents.
64
+#
65
+# The short X.Y version.
66
+# The full version, including alpha/beta/rc tags.
67
+release = ''
68
+# The short X.Y version.
69
+version = ''
70
+
71
+# The language for content autogenerated by Sphinx. Refer to documentation
72
+# for a list of supported languages.
73
+# language = None
74
+
75
+# There are two options for replacing |today|: either, you set today to some
76
+# non-false value, then it is used:
77
+# today = ''
78
+# Else, today_fmt is used as the format for a strftime call.
79
+# today_fmt = '%B %d, %Y'
80
+
81
+# List of patterns, relative to source directory, that match files and
82
+# directories to ignore when looking for source files.
83
+exclude_patterns = []
84
+
85
+# The reST default role (used for this markup: `text`) to use for all
86
+# documents.
87
+# default_role = None
88
+
89
+# If true, '()' will be appended to :func: etc. cross-reference text.
90
+# add_function_parentheses = True
91
+
92
+# If true, the current module name will be prepended to all description
93
+# unit titles (such as .. function::).
94
+# add_module_names = True
95
+
96
+# If true, sectionauthor and moduleauthor directives will be shown in the
97
+# output. They are ignored by default.
98
+# show_authors = False
99
+
100
+# The name of the Pygments (syntax highlighting) style to use.
101
+pygments_style = 'sphinx'
102
+
103
+# A list of ignored prefixes for module index sorting.
104
+# modindex_common_prefix = []
105
+
106
+# If true, keep warnings as "system message" paragraphs in the built documents.
107
+# keep_warnings = False
108
+
109
+
110
+# -- Options for HTML output ----------------------------------------------
111
+
112
+# The theme to use for HTML and HTML Help pages.  See the documentation for
113
+# a list of builtin themes.
114
+html_theme = 'default'
115
+
116
+# Theme options are theme-specific and customize the look and feel of a theme
117
+# further.  For a list of options available for each theme, see the
118
+# documentation.
119
+# html_theme_options = {}
120
+
121
+# Add any paths that contain custom themes here, relative to this directory.
122
+# html_theme_path = []
123
+
124
+# The name for this set of Sphinx documents.  If None, it defaults to
125
+# "<project> v<release> documentation".
126
+# html_title = None
127
+
128
+# A shorter title for the navigation bar.  Default is the same as html_title.
129
+# html_short_title = None
130
+
131
+# The name of an image file (relative to this directory) to place at the top
132
+# of the sidebar.
133
+# html_logo = None
134
+
135
+# The name of an image file (within the static path) to use as favicon of the
136
+# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
137
+# pixels large.
138
+# html_favicon = None
139
+
140
+# Add any paths that contain custom static files (such as style sheets) here,
141
+# relative to this directory. They are copied after the builtin static files,
142
+# so a file named "default.css" will overwrite the builtin "default.css".
143
+html_static_path = ['_static']
144
+
145
+# Add any extra paths that contain custom files (such as robots.txt or
146
+# .htaccess) here, relative to this directory. These files are copied
147
+# directly to the root of the documentation.
148
+# html_extra_path = []
149
+
150
+# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
151
+# using the given strftime format.
152
+# html_last_updated_fmt = '%b %d, %Y'
153
+
154
+# If true, SmartyPants will be used to convert quotes and dashes to
155
+# typographically correct entities.
156
+# html_use_smartypants = True
157
+
158
+# Custom sidebar templates, maps document names to template names.
159
+# html_sidebars = {}
160
+
161
+# Additional templates that should be rendered to pages, maps page names to
162
+# template names.
163
+# html_additional_pages = {}
164
+
165
+# If false, no module index is generated.
166
+# html_domain_indices = True
167
+
168
+# If false, no index is generated.
169
+# html_use_index = True
170
+
171
+# If true, the index is split into individual pages for each letter.
172
+# html_split_index = False
173
+
174
+# If true, links to the reST sources are added to the pages.
175
+# html_show_sourcelink = True
176
+
177
+# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
178
+# html_show_sphinx = True
179
+
180
+# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
181
+# html_show_copyright = True
182
+
183
+# If true, an OpenSearch description file will be output, and all pages will
184
+# contain a <link> tag referring to it.  The value of this option must be the
185
+# base URL from which the finished HTML is served.
186
+# html_use_opensearch = ''
187
+
188
+# This is the file name suffix for HTML files (e.g. ".xhtml").
189
+# html_file_suffix = None
190
+
191
+# Output file base name for HTML help builder.
192
+htmlhelp_basename = 'GlanceReleaseNotesdoc'
193
+
194
+
195
+# -- Options for LaTeX output ---------------------------------------------
196
+
197
+latex_elements = {
198
+    # The paper size ('letterpaper' or 'a4paper').
199
+    # 'papersize': 'letterpaper',
200
+
201
+    # The font size ('10pt', '11pt' or '12pt').
202
+    # 'pointsize': '10pt',
203
+
204
+    # Additional stuff for the LaTeX preamble.
205
+    # 'preamble': '',
206
+}
207
+
208
+# Grouping the document tree into LaTeX files. List of tuples
209
+# (source start file, target name, title,
210
+#  author, documentclass [howto, manual, or own class]).
211
+latex_documents = [
212
+    ('index', 'GlanceReleaseNotes.tex', u'Glance Release Notes Documentation',
213
+     u'Glance Developers', 'manual'),
214
+]
215
+
216
+# The name of an image file (relative to this directory) to place at the top of
217
+# the title page.
218
+# latex_logo = None
219
+
220
+# For "manual" documents, if this is true, then toplevel headings are parts,
221
+# not chapters.
222
+# latex_use_parts = False
223
+
224
+# If true, show page references after internal links.
225
+# latex_show_pagerefs = False
226
+
227
+# If true, show URL addresses after external links.
228
+# latex_show_urls = False
229
+
230
+# Documents to append as an appendix to all manuals.
231
+# latex_appendices = []
232
+
233
+# If false, no module index is generated.
234
+# latex_domain_indices = True
235
+
236
+
237
+# -- Options for manual page output ---------------------------------------
238
+
239
+# One entry per manual page. List of tuples
240
+# (source start file, name, description, authors, manual section).
241
+man_pages = [
242
+    ('index', 'glancereleasenotes', u'Glance Release Notes Documentation',
243
+     [u'Glance Developers'], 1)
244
+]
245
+
246
+# If true, show URL addresses after external links.
247
+# man_show_urls = False
248
+
249
+
250
+# -- Options for Texinfo output -------------------------------------------
251
+
252
+# Grouping the document tree into Texinfo files. List of tuples
253
+# (source start file, target name, title, author,
254
+#  dir menu entry, description, category)
255
+texinfo_documents = [
256
+    ('index', 'GlanceReleaseNotes', u'Glance Release Notes Documentation',
257
+     u'Glance Developers', 'GlanceReleaseNotes',
258
+     'One line description of project.',
259
+     'Miscellaneous'),
260
+]
261
+
262
+# Documents to append as an appendix to all manuals.
263
+# texinfo_appendices = []
264
+
265
+# If false, no module index is generated.
266
+# texinfo_domain_indices = True
267
+
268
+# How to display URL addresses: 'footnote', 'no', or 'inline'.
269
+# texinfo_show_urls = 'footnote'
270
+
271
+# If true, do not generate a @detailmenu in the "Top" node's menu.
272
+# texinfo_no_detailmenu = False
273
+
274
+# -- Options for Internationalization output ------------------------------
275
+locale_dirs = ['locale/']

+ 8
- 0
releasenotes/source/index.rst View File

@@ -0,0 +1,8 @@
1
+============================================
2
+ devstack_plugin_libvirt_qemu Release Notes
3
+============================================
4
+
5
+.. toctree::
6
+   :maxdepth: 1
7
+
8
+   unreleased

+ 5
- 0
releasenotes/source/unreleased.rst View File

@@ -0,0 +1,5 @@
1
+==============================
2
+ Current Series Release Notes
3
+==============================
4
+
5
+.. release-notes::

+ 5
- 0
requirements.txt View File

@@ -0,0 +1,5 @@
1
+# The order of packages is significant, because pip processes them in the order
2
+# of appearance. Changing the order has an impact on the overall integration
3
+# process, which may cause wedges in the gate later.
4
+
5
+pbr>=2.0 # Apache-2.0

+ 47
- 0
setup.cfg View File

@@ -0,0 +1,47 @@
1
+[metadata]
2
+name = devstack-plugin-libvirt-qemu
3
+summary = OpenStack Boilerplate contains all the boilerplate you need to create an OpenStack package.
4
+description-file =
5
+    README.rst
6
+author = OpenStack
7
+author-email = openstack-dev@lists.openstack.org
8
+home-page = http://www.openstack.org/
9
+classifier =
10
+    Environment :: OpenStack
11
+    Intended Audience :: Information Technology
12
+    Intended Audience :: System Administrators
13
+    License :: OSI Approved :: Apache Software License
14
+    Operating System :: POSIX :: Linux
15
+    Programming Language :: Python
16
+    Programming Language :: Python :: 2
17
+    Programming Language :: Python :: 2.7
18
+    Programming Language :: Python :: 3
19
+    Programming Language :: Python :: 3.3
20
+    Programming Language :: Python :: 3.4
21
+
22
+[files]
23
+packages =
24
+    devstack_plugin_libvirt_qemu
25
+
26
+[build_sphinx]
27
+all-files = 1
28
+warning-is-error = 1
29
+source-dir = doc/source
30
+build-dir = doc/build
31
+
32
+[upload_sphinx]
33
+upload-dir = doc/build/html
34
+
35
+[compile_catalog]
36
+directory = devstack_plugin_libvirt_qemu/locale
37
+domain = devstack_plugin_libvirt_qemu
38
+
39
+[update_catalog]
40
+domain = devstack_plugin_libvirt_qemu
41
+output_dir = devstack_plugin_libvirt_qemu/locale
42
+input_file = devstack_plugin_libvirt_qemu/locale/devstack_plugin_libvirt_qemu.pot
43
+
44
+[extract_messages]
45
+keywords = _ gettext ngettext l_ lazy_gettext
46
+mapping_file = babel.cfg
47
+output_file = devstack_plugin_libvirt_qemu/locale/devstack_plugin_libvirt_qemu.pot

+ 29
- 0
setup.py View File

@@ -0,0 +1,29 @@
1
+# Copyright (c) 2013 Hewlett-Packard Development Company, L.P.
2
+#
3
+# Licensed under the Apache License, Version 2.0 (the "License");
4
+# you may not use this file except in compliance with the License.
5
+# You may obtain a copy of the License at
6
+#
7
+#    http://www.apache.org/licenses/LICENSE-2.0
8
+#
9
+# Unless required by applicable law or agreed to in writing, software
10
+# distributed under the License is distributed on an "AS IS" BASIS,
11
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
12
+# implied.
13
+# See the License for the specific language governing permissions and
14
+# limitations under the License.
15
+
16
+# THIS FILE IS MANAGED BY THE GLOBAL REQUIREMENTS REPO - DO NOT EDIT
17
+import setuptools
18
+
19
+# In python < 2.7.4, a lazy loading of package `pbr` will break
20
+# setuptools if some other modules registered functions in `atexit`.
21
+# solution from: http://bugs.python.org/issue15881#msg170215
22
+try:
23
+    import multiprocessing  # noqa
24
+except ImportError:
25
+    pass
26
+
27
+setuptools.setup(
28
+    setup_requires=['pbr>=2.0'],
29
+    pbr=True)

+ 16
- 0
test-requirements.txt View File

@@ -0,0 +1,16 @@
1
+# The order of packages is significant, because pip processes them in the order
2
+# of appearance. Changing the order has an impact on the overall integration
3
+# process, which may cause wedges in the gate later.
4
+
5
+hacking>=0.12.0,<0.13 # Apache-2.0
6
+
7
+coverage>=4.0 # Apache-2.0
8
+python-subunit>=0.0.18 # Apache-2.0/BSD
9
+sphinx>=1.5.1,<1.6 # BSD
10
+oslosphinx>=4.7.0 # Apache-2.0
11
+oslotest>=1.10.0 # Apache-2.0
12
+testrepository>=0.0.18  # Apache-2.0/BSD
13
+testtools>=1.4.0 # MIT
14
+
15
+# releasenotes
16
+reno>=1.8.0 # Apache-2.0

+ 49
- 0
tox.ini View File

@@ -0,0 +1,49 @@
1
+[tox]
2
+minversion = 2.0
3
+envlist = bashate
4
+skipsdist = True
5
+
6
+[testenv]
7
+usedevelop = True
8
+install_command = pip install -c{env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt} {opts} {packages}
9
+setenv =
10
+   VIRTUAL_ENV={envdir}
11
+   PYTHONWARNINGS=default::DeprecationWarning
12
+deps = -r{toxinidir}/test-requirements.txt
13
+commands = python setup.py test --slowest --testr-args='{posargs}'
14
+
15
+[testenv:bashate]
16
+# if you want to test out some changes you have made to bashate
17
+# against devstack, just set BASHATE_INSTALL_PATH=/path/... to your
18
+# modified bashate tree
19
+deps =
20
+   {env:BASHATE_INSTALL_PATH:bashate==0.5.1}
21
+whitelist_externals = bash
22
+commands = bash -c "find {toxinidir}             \
23
+         -not \( -type d -name .?\* -prune \)    \
24
+         -not \( -type d -name doc -prune \)     \
25
+         -not \( -type f -name localrc -prune \) \
26
+         -type f                                 \
27
+         -not -name \*~                          \
28
+         -not -name \*.md                        \
29
+         -not -name stack-screenrc               \
30
+         -not -name \*.orig                      \
31
+         -not -name \*.rej                       \
32
+         \(                                      \
33
+          -name \*.sh -or                        \
34
+          -name \*rc -or                         \
35
+          -name functions\* -or                  \
36
+          -wholename \*/inc/\* -or               \
37
+          -wholename \*/lib/\*                   \
38
+         \)                                      \
39
+         -print0 | xargs -0 bashate -v -iE006 -eE005,E042"
40
+
41
+[testenv:docs]
42
+commands = python setup.py build_sphinx
43
+
44
+[testenv:releasenotes]
45
+commands =
46
+  sphinx-build -a -E -W -d releasenotes/build/doctrees -b html releasenotes/source releasenotes/build/html
47
+
48
+[testenv:debug]
49
+commands = oslo_debug_helper {posargs}

Loading…
Cancel
Save